<script setup lang="ts">
import FileLoadButton from "@/components/FileLoadButton.vue";
import { getFileExtension, upload_single_file } from "@/functions";
import { reactive } from "vue";
import ROOT_URL from "@/../settings";

const ALLOWED_EXTENSIONS: Array<string> = ["jsonocel", "xmlocel"];

let state = reactive<{
  filename: string;
  extension: string;
  uploading: boolean;
}>({
  filename: "",
  extension: "jsonocel",
  uploading: false,
});

const emit = defineEmits<{
  (e: "uploadstart"): void;
  (e: "uploadfinished", id: string): void;
  (e: "uploadfailed", description: string): void;
}>();

async function fileSelected(data: File) {
  state.filename = data.name;
  const tmp_ext = getFileExtension(data.name);
  state.extension = tmp_ext ? tmp_ext : "";
  if (!ALLOWED_EXTENSIONS.includes(state.extension))
    throw Error(
      "returned file is not a valid ocel-format! Use on of ''" +
        ALLOWED_EXTENSIONS.map((e) => "." + e).join("', '") +
        "'."
    );
  state.uploading = true;
  emit("uploadstart");
  const response = await upload_single_file(
    data,
    ROOT_URL + "/ocel-upload",
    "file",
    "POST"
  );
  state.uploading = false;

  const content_type = response.headers.get("content-type");
  if (content_type == "application/json") {
    const res = await response.json();

    if (response.status == 200) {
      emit("uploadfinished", res.data.id);
    } else {
      emit("uploadfailed", res.errors[0].description);
    }
  } else {
    emit("uploadfailed", "technical error: No json returned by the api");
  }
}
</script>

<template>
  <FileLoadButton fileTypes=".jsonocel,.xmlocel" @change="fileSelected">
    <slot v-if="!state.uploading"></slot>
    <span
      v-if="state.uploading"
      class="spinner-border spinner-border-sm"
      role="status"
      aria-hidden="true"
    ></span>
    {{ state.uploading ? "Loading..." : "" }}
  </FileLoadButton>
</template>
